/**
Duminda GUnasekara : 11/09/2015    -    Removed hard coded produciton Mule URL and dynamically calls corresponding Mule instance
Duminda GUnasekara : 11/10/2015    -    Removed hard coded link in the approval email

*/
public class GRD_XmlWriter
{
    public class JSONresult
    {
        public Integer Row;
        public Id SFID;
        public String GUID;
        public String Status;
        public String Error;
    }
    
    public class Borehole
    {
        public String id;
        public String name;
        public String status;
        public String grdGuid;
        public String wellviewBoreGuid;
        public String wellviewBoreGuidMappingGUID; // this is the GUID from the T_MASTER_DATA_MAPPING table
        public String wellClass;
        public String targetFormation;
        public String wellType;
        public String wellCategory;
        public String geologist;
        //Location Information
        public String operatingField;
        public String operatingFieldId;
        public String surfaceLocation; 
        public String surfaceLocId;
        public String targetLocation;
        public String targetLocId;
        public String uwiLocation;
        public String uwiLocId;
        public Decimal measuredDepth;
        public Decimal horizontalLength;
        public Decimal workingInterest;
        public Decimal trueVerticalDepth;
        public String opNonOp;
        public String strategy;
        public String pool;
        public String primaryProduct;
        public Decimal risk;
        public String arcGUID;
        public String pvrGUID;  
        public String typeCurveGUID;   
        public String AMUGUID;    
        
        public Integer noOfCompletions;
        //associated well is uwi location which allows multiple bores to be associated to a well
        public String associatedWell;
        //if there is an error while saving to database, this flag is checked by Mule
        public String errorInDb;
        // Flag is true while DB is updating record
        public String refreshingFromDB;
        
        public List<Completion> completions;
        
        public List<GUIDMapping> GUIDMappings;
    }
    
    public class Completion
    {
        public String id;
        public String name;
        public String completionGuid;
        //Decimal completionId;
        public String categoryIsolation;
        public String completionFluid;
        public String numberOfStages;
        public String sizeOfStages;
        public String proppantSize;
        public String proppantType;
        public String wellId;
    }
    
    public class GUIDMapping
    {
        public String wellViewZoneSFID;
        public String wellViewZoneGUID;
        public String WellViewZone;
        public String PVRWellSFID;
        public String PVRWellGUID;
        public String PVRWell;
    }
    
    // This processes class D wells submitted for approval and sends approval emails out
    public static void processClassDsSubmittedForApproval(String rowJSON)
    {
        List<Borehole> bhList = (List<Borehole>)JSON.deserialize(rowJSON, List<Borehole>.class);
        // Create a list of the wellIds
        Set<Id> wellIds = new Set<Id>();
        for(Borehole bh:bhList) {
            wellIds.add(bh.id);
        }
        // Create a list of all the wells
        List<Class_D_Well__c> wells = [SELECT Id, 
                                      Name,
                                      Target_Formation__c,
                                      Measured_Depth__c,
                                      Horizontal_Length__c,
                                      True_Vertical_Depth__c,
                                      Well_Type__c,
                                      Geologist__c,
                                      Well_Category__c,
                                      Working_Interest__c,
                                      Surface_Location__c,
                                      Target_Location__c,
                                      UWI_Location__c,
                                      Associated_Well__c,
                                      RecordTypeId,
                                      RecordType.DeveloperName,
                                      (SELECT Id,
                                              Name,
                                              CategoryIsolationCode__c,
                                              CompletionFluid__c,
                                              NumberOfFracs__c,
                                              TProppantPerFrac__c
                                      FROM Class_D_Well_Completions__r)
                                      FROM Class_D_Well__c
                                      WHERE Id IN: wellIds];
        
        Map<String, List<Class_D_Well__c>> schemaName2Wells = new Map<String, List<Class_D_Well__c>>();
        
        for(Class_D_Well__c well : wells)
        {
            if(!schemaName2Wells.containsKey(well.RecordType.DeveloperName))
                schemaName2Wells.put(well.RecordType.DeveloperName, new List<Class_D_Well__c>());
            
            schemaName2Wells.get(well.RecordType.DeveloperName).add(well);
        }
        
        for(String schemaName : schemaName2Wells.keySet())
        {
            String rolename = WCPRoles.schemaName2RoleName(schemaName)+' - Approver';
            
            // Get a list of approvers to send to with role of Gas Resource Development - Manager
            List<User> approvers = [SELECT id, firstName, lastName, email, Name, UserRole.name FROM User WHERE UserRole.Name =: rolename];
            System.debug('approvers =' + approvers);
            String emailReason = 'approval';
            
            if (approvers.size() > 0)
            {
              // Send email to approvers about the wells needing approval
              GRD_XMLWriter.emailWellApprover(approvers, schemaName2Wells.get(schemaName), emailReason);
            }
        }
        
        return;
    }
        
    
    /*
     * Takes an array of Borehole objects (see declaration at top of file) and emails submitters
     * to inform them the boreholes have been recalled from submission.
     */
    public static void processClassDsSubmittedForRecall(String rowJSON)
    {
        List<Borehole> bhList = (List<Borehole>)JSON.deserialize(rowJSON, List<Borehole>.class);
        // Create a list of the wellIds
        Set<Id> wellIds = new Set<Id>();
        for(Borehole bh:bhList) {
            wellIds.add(bh.id);
        }
        // Create a list of all the wells
        List<Class_D_Well__c> wells = [SELECT Id, 
                                              Name,
                                              Target_Formation__c,
                                              Measured_Depth__c,
                                              Horizontal_Length__c,
                                              True_Vertical_Depth__c,
                                              Well_Type__c,
                                              Geologist__c,
                                              Well_Category__c,
                                              Working_Interest__c,
                                              Surface_Location__c,
                                              Target_Location__c,
                                              UWI_Location__c,
                                              Associated_Well__c,
                                              RecordTypeId,
                                              RecordType.Id,
                                              RecordType.DeveloperName,
                                              (SELECT Id,
                                                      Name,
                                                      CategoryIsolationCode__c,
                                                      CompletionFluid__c,
                                                      NumberOfFracs__c,
                                                      TProppantPerFrac__c
                                              FROM Class_D_Well_Completions__r)
                                              FROM Class_D_Well__c
                                              WHERE Id IN: wellIds];
        
        Map<String, List<Class_D_Well__c>> schemaName2Wells = new Map<String, List<Class_D_Well__c>>();
        
        for(Class_D_Well__c well : wells)
        {
            if(!schemaName2Wells.containsKey(well.RecordType.DeveloperName))
                schemaName2Wells.put(well.RecordType.DeveloperName, new List<Class_D_Well__c>());
            
            schemaName2Wells.get(well.RecordType.DeveloperName).add(well);
        }
        
        for(String schemaName : schemaName2Wells.keySet())
        {
            String rolename = WCPRoles.schemaName2RoleName(schemaName)+' - Approver';
            
            // Get a list of approvers to send to with role of Gas Resource Development - Manager
            List<User> approvers = [SELECT id, firstName, lastName, email, Name, UserRole.name FROM User WHERE UserRole.Name =: rolename];
        
            String emailReason = 'recalled';
        
            // Send email to approvers about the wells needing approval
            GRD_XMLWriter.emailWellApprover(approvers, schemaName2Wells.get(schemaName), emailReason);
        }
        
        return;
    }
    
    public static void processClassDsSubmittedForRejection(String rowJSON)
    {
        List<Borehole> bhList = (List<Borehole>)JSON.deserialize(rowJSON, List<Borehole>.class);
        
        // Create a list of the wellIds
        Set<Id> wellIds = new Set<Id>();
        for(Borehole bh:bhList) {
            wellIds.add(bh.id);
        }
        
        // Create a list of all the wells
        List<Class_D_Well__c> wells = [SELECT Id, 
                                              Name,
                                              OwnerId,
                                              Owner.email,
                                              Target_Formation__c,
                                              Measured_Depth__c,
                                              Horizontal_Length__c,
                                              True_Vertical_Depth__c,
                                              Well_Type__c,
                                              Geologist__c,
                                              Well_Category__c,
                                              Working_Interest__c,
                                              Surface_Location__c,
                                              Target_Location__c,
                                              UWI_Location__c,
                                              Associated_Well__c,
                                              (SELECT Id,
                                                      Name,
                                                      CategoryIsolationCode__c,
                                                      CompletionFluid__c,
                                                      NumberOfFracs__c,
                                                      TProppantPerFrac__c
                                              FROM Class_D_Well_Completions__r)
                                              FROM Class_D_Well__c
                                              WHERE Id IN: wellIds];
        
        // Group wells by their record owner
        Map<User,List<Class_D_Well__c>> owners2wells = new Map<User,List<Class_D_Well__c>>();
        
        for(Class_D_Well__c well : wells)
        {
            User recordOwner = new User(Id = well.OwnerId, email = well.Owner.email);
            
            if(!owners2wells.containsKey(recordOwner))
                owners2wells.put(recordOwner, new List<Class_D_Well__c>());
            
            owners2wells.get(recordOwner).add(well);
        }
        
        // Send email to record owners saying their wells have been rejected.
        for(User recordOwner : owners2wells.keySet())
        {
            if(!Test.isRunningTest())
            {
               GRD_XMLWriter.emailWellApprover(new List<User>{recordOwner}, owners2wells.get(recordOwner), 'rejected');
            }
        }
        
        return;
    }
    
    public static Map<String,Map<Id,String>> processClassDsAppoved(String rowJSON, String schemaName)
    {
        if(schemaName.startsWith('GRD')) schemaName = 'GRD';
        if(schemaName.startsWith('WCP_SC')) schemaName = 'WCP_SC';
        
        List<Borehole> bhList = (List<Borehole>)JSON.deserialize(rowJSON, List<Borehole>.class);
        
        // Create a list of the well ids
        Set<Id> wellIds = new Set<Id>();
        for(Borehole bh:bhList) {
            wellIds.add(bh.id);
        }
        
        // Gather up all class d well record types
        Map<Id,String> classDRecordTypes = new Map<Id,String>();
        
        for(Class_D_Well__c w : [SELECT Id, RecordType.Id, RecordType.DeveloperName FROM Class_D_Well__c WHERE Id IN: wellIds])
        {
            if(!classDRecordTypes.containsKey(w.RecordType.Id))
                classDRecordTypes.put(w.RecordType.Id,w.RecordType.DeveloperName);
        }
        
        Map<String,Map<Id,String>> allresults = new Map<String,Map<Id,String>>();
        // Group wells by their record owner
        Map<User,List<Class_D_Well__c>> owners2wells = new Map<User,List<Class_D_Well__c>>();
        for(Id rtid : classDRecordTypes.keySet())
        {
            
            schemaName = classDRecordTypes.get(rtid);
            System.debug('processClassDApproved schema =' + schemaName);
            System.debug('wellIds =' + wellIds);
             
            // Create a list of all the wells
            // Fetch the class D wells we need and the appropriate fields
            // As well as the well completion child relationships associated with the wells
            Map<Id, Class_D_Well__c> wells = new Map<Id, Class_D_Well__c>([SELECT Id, 
                                                  Name,
                                                  OwnerId,
                                                  Owner.email,
                                                  Target_Formation__c,
                                                  Measured_Depth__c,
                                                  Horizontal_Length__c,
                                                  True_Vertical_Depth__c,
                                                  Well_Type__c,
                                                  Geologist__c,
                                                  Well_Category__c,
                                                  Working_Interest__c,
                                                  Surface_Location__c,
                                                  Target_Location__c,
                                                  UWI_Location__c,
                                                  Associated_Well__c,
                                                  Strategy__c,
                                                  Pool__c,
                                                  Risked__c,
                                                  Op_Non_Op__c,
                                                  Primary_Product__c,
                                                  RecordTypeId,
                                                  RecordType.DeveloperName,
                                                  Operating_Field__c,
                                                  (SELECT Id, 
                                                          Name,
                                                          CategoryIsolationCode__c,
                                                          CompletionFluid__c,
                                                          NumberOfFracs__c,
                                                          TProppantPerFrac__c,
                                                          Proppant_Size__c,
                                                          Proppant_Type__c
                                                  FROM Class_D_Well_Completions__r)
                                                  FROM Class_D_Well__c
                                                  WHERE Id IN: wellIds AND RecordTypeId =: rtid]);
            
             
              
          // Create an approver for use in the xmlwriter call
          User approver = [SELECT id, firstName, lastName, email, Name FROM User WHERE Id =: UserInfo.getUserId() LIMIT 1];
          
          // We know these wells are approved because all wells passed into this call are marked as approved
          Boolean isApproved = true;
          
          // Set userEmail to approver email for now
          String userEmail = approver.email;
          
          // Pass the well list into the XML Generation function with approver, is approved, and approver email
          Dom.Document doc = GRD_XmlWriter.generateClassDXML(wells.values(), approver, isApproved, userEmail);
          
          // Send that XML to Mule to pass it on to the database.
          Map<String,Map<Id,String>> results = sendXMLtoMule(doc, wells.keySet(),'D', schemaName);
          
          
          
          for(Class_D_Well__c well : wells.values())
          {
              if(results.containsKey('Success') && results.get('Success').containsKey(well.Id))
              {
                  User recordOwner = new User(Id = well.OwnerId, email = well.Owner.email);
                  
                  if(!owners2wells.containsKey(recordOwner))
                      owners2wells.put(recordOwner, new List<Class_D_Well__c>());
                  
                  if(results.containsKey('Success') && results.get('Success').containsKey(well.Id))
                      owners2wells.get(recordOwner).add(well);
              }
          }
          for(String answer : results.keySet())
          {
              if(!allresults.containsKey(answer))
                  allresults.put(answer,new Map<Id,String>());
              
              for(Id x : results.get(answer).keySet())
                  allresults.get(answer).put(x,results.get(answer).get(x));
          }
      }
      // Send email to record owners saying their wells have been approved.
      for(User recordOwner : owners2wells.keySet())
      {
          if(owners2wells.containsKey(recordOwner) && owners2wells.get(recordOwner).size() > 0)
              GRD_XMLWriter.emailWellApprover(new List<User>{recordOwner}, owners2wells.get(recordOwner), 'approved');
      }
      return allresults;
    }
    
    public static Map<String,Map<Id,String>> processClassCsUpdated(String rowJSON, String schemaName)
    {
       
        if(schemaName.startsWith('GRD')) schemaName = 'GRD';
        if(schemaName.startsWith('WCP_SC')) schemaName = 'WCP_SC';
        
        // Create a list of the well ids
        List<Borehole> bhList = (List<Borehole>)JSON.deserialize(rowJSON, List<Borehole>.class);
        Set<Id> wellIds = new Set<Id>();
        for(Borehole bh:bhList)
        {
            wellIds.add(bh.id);
        }
        
        Map<Id,String> classCRecordTypes = new Map<Id,String>();
        Map<Id, Set<Id>> wellIdsByRecordType = new Map<Id, Set<Id>>();
        
        for(GRD_Borehole__c w : [SELECT Id, RecordType.Id, RecordType.DeveloperName FROM GRD_Borehole__c WHERE Id IN: wellIds])
        {
            if(!classCRecordTypes.containsKey(w.RecordType.Id))
                classCRecordTypes.put(w.RecordType.Id,w.RecordType.DeveloperName);
            if(!wellIdsByRecordType.containsKey(w.RecordType.Id))
                wellIdsByRecordType.put(w.RecordType.Id,new Set<Id>());
            wellIdsByRecordType.get(w.RecordType.Id).add(w.Id);
        }
        
        // Create an approver for use in the xmlwriter call
        User approver = [SELECT id, firstName, lastName, email, Name FROM User WHERE Id =: UserInfo.getUserId() LIMIT 1];
        
        // We know these wells are approved because all wells passed into this call are marked as approved
        Boolean isApproved = true;
        
        // Set userEmail to approver email for now
        String userEmail = approver.email;
        
        Map<String,Map<Id,String>> allresults = new Map<String,Map<Id,String>>();
        
        // For each schema, generate the XML and send it.
        for(Id eachRecordType : classCRecordTypes.keySet())
        {
            
            // Generate XML for the borehole updates
            Dom.Document doc = GRD_XmlWriter.generateClassCXML(bhList, wellIdsByRecordType.get(eachRecordType), userEmail);
        
            // Send that XML to Mule to pass it on to the database.
            Map<String,Map<Id,String>> results = sendXMLtoMule(doc, wellIds, 'C', classCRecordTypes.get(eachRecordType));
            System.debug('result =' + results);
            // For every well that was successfully updated, we'll mark that well as being refreshed.
            if(results.containsKey('Success'))
            {
                List<GRD_Borehole__c> successfulBoreholes = new List<GRD_Borehole__c>();
                for(Id boreholeId : results.get('Success').keySet())
                {
                    successfulBoreholes.add(new GRD_Borehole__c(Id = boreholeId, Refreshing_From_DB__c = True));
                }
                update successfulBoreholes;
            }
            
            for(String answer : results.keySet())
            {
                if(!allresults.containsKey(answer))
                    allresults.put(answer,new Map<Id,String>());
                
                for(Id x : results.get(answer).keySet())
                    allresults.get(answer).put(x,results.get(answer).get(x));
            }
        
        }
        
        return allResults;
    }
    
    // This method takes a user that needs to approve some wells, and a list of the wells
    // to be approved, and lets them know they need to approve them
    // It takes in the approver with an email, the list of wells or well, and the reason for the email
    // Reason can be "approval", "approved", "recalled", or "rejected"
    public static void emailWellApprover(List<User> approvers, List<Class_D_Well__c> wellList, String emailReason) {
        // First, reserve email capacity for the current Apex transaction to ensure            
        // that we won't exceed our daily email limits when sending email after

        // the current transaction is committed.
        Messaging.reserveSingleEmailCapacity(1);

        // Processes and actions involved in the Apex transaction occur next,
        // which conclude with sending a single email.

        // Now create a new single email message object
        // that will send out a single email to the addresses in the To, CC & BCC list.
        Messaging.SingleEmailMessage mail = new Messaging.SingleEmailMessage();
        mail.setCharset('UTF-8');
        
        // String to hold the email address of the approvers
        String toRecipients = '';
        // Loop through each approver if multiple and add it to the toRecipients string
        for(User approver : approvers) {
            toRecipients += approver.email + ';';
        }
        toRecipients = toRecipients.removeEnd(';');

        String[] toAddresses = toRecipients.split(';', 0);
        
        // Assign the addresses for the To and CC lists to the mail object.
        mail.setToAddresses(toAddresses);

        // Specify the address used when the recipients reply to the email. 
        mail.setReplyTo('noreply@salesforce.com');

        // Specify the name used as the display name.
        mail.setSenderDisplayName('Husky Internal');

        // Specify the subject line for your email address depending on reason of email
        if(emailReason == 'approval') {
            mail.setSubject('Wells Needing Approval');  
        }
        if(emailReason == 'approved') {
            mail.setSubject('Well Approved');   
        }
        if(emailReason == 'recalled') {
            mail.setSubject('Well Recalled');   
        }
        if(emailReason == 'rejected') {
            mail.setSubject('Well Rejected');   
        }
        
        // Set to True if you want to BCC yourself on the email.
        mail.setBccSender(false);

        // Optionally append the salesforce.com email signature to the email.
        // The email address of the user executing the Apex Code will be used.
        mail.setUseSignature(false);

        // Specify the text content of the email depending on email reason
        String messageBody = '';
        if(emailReason == 'approval') {
            messageBody += 'Hi,\n\nThe following Class D wells have been submitted for your approval: ';
        }
        if(emailReason == 'approved') {
            messageBody += 'Hi,\n\nThe following Class D well has been approved: ';
        }
        if(emailReason == 'recalled') {
            messageBody += 'Hi,\n\nThe following Class D well has been recalled: ';
        }
        if(emailReason == 'rejected') {
            messageBody += 'Hi,\n\nThe following Class D well has been rejected: ';
        }
        
        // Add a list of the wells to the email using surface location, uwi location and target formation
        for(Class_D_Well__c well : wellList) {
            messageBody += '\n\u2022 ' + well.Surface_Location__c + ', ' + well.UWI_Location__c + ', ' + well.Target_Formation__c + '\n\n';
        }
        
        // Set other text depending on the reason
        if(emailReason == 'approval') {
            // Get the link to add where the approver can approver the wells at
            //String GRD_Well_Inventory_url = URL.getSalesforceBaseUrl() + '/servlet/servlet.Integration?lid=01rZ000000095Hf&ic=1';
            //GRD_Well_Inventory_url = GRD_Well_Inventory_url.replace('Url:[delegate=', '');
            //GRD_Well_Inventory_url = GRD_Well_Inventory_url.replace(']', '');
            String GRD_Well_Inventory_url = URL.getSalesforceBaseUrl() + '/apex/GRDWellInventory';
            GRD_Well_Inventory_url = GRD_Well_Inventory_url.replace('Url:[delegate=', '');
            GRD_Well_Inventory_url = GRD_Well_Inventory_url.replace(']', '');            
            
            // Add link to email message
            messageBody += '\n\nGo to the link below or the GRD Well Inventory tab in Salesforce to approve the above wells.\n' +
            GRD_Well_Inventory_url; 
        }
        
        // Set the plaintext body for the email
        mail.setPlainTextBody(messageBody);

        // Send the email message to the user
        if(!Test.isRunningTest())
        {
            Messaging.sendEmail(new Messaging.SingleEmailMessage[] { mail });
        }
    }
    
    // This method generates an XML request from a set of wellIds
    public static Dom.Document generateClassDXML(List<Class_D_Well__c> wells,
                                                 User    approver,
                                                 Boolean isApproved,
                                                 String  userEmail)
    {
        // Xml created using DOM Xml
        // Create the request envelope
        DOM.Document doc = new DOM.Document();
        
        
        
        // Select the Operating Fields and Districts used by those Class D Wells. We'll need to send them too.
        Set<String> fieldNames = new Set<String>();
        Map<String,Field__c> fields = new Map<String,Field__c>();
        
        for(Class_D_Well__c well : wells)
        {
            fieldNames.add(well.Operating_Field__c);
system.debug('mikep well.Operating_Field__c '+well.Operating_Field__c);
        }
system.debug('mikep fieldNames '+fieldNames);
        
        List<Field__c> fieldData = [SELECT Id,
                                           Name,
                                           GRD_ID__c,
                                           Operating_District__c,
                                           Operating_District__r.Name,
                                           Operating_District__r.GRD_ID__c,
                                           AMU_GUID__c
                                    FROM Field__c
                                    WHERE Name IN: fieldNames AND AMU_GUID__c != null];
        
        for(Field__c eachField : fieldData)
        {
            if(!fields.containsKey(eachField.Name))
                fields.put(eachField.Name, eachField);
        }
        
        // Set up the URL to the namespace
        String namespace = 'http://wcp.huskyenergy.com/wellentry';
        
        /* Start well_message block */
        // Create the root element wellMessage and add attributes needed
        dom.XmlNode wellMessage = doc.createRootElement('well_message', namespace, 'wcp');
        wellMessage.setAttribute('xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
        wellMessage.setAttribute('xsi:schemaLocation', 'http://wcp.huskyenergy.com/wellentry http://wcp.huskyenergy.com/wellentry');

        /* Start header information for well_message block */

        // session_id
        // This is the email of the user that sent the create action concat. to the current timestamp
        wellMessage.addChildElement('session_id', namespace, 'wcp').
        addTextNode(userEmail+'@'+string.valueof(System.now()).replace(' ', 'T'));

        // message_dttm
        // This is the date/time for the message
        wellMessage.addChildElement('message_dttm', namespace, 'wcp').
        addTextNode(string.valueof(System.now()).replace(' ', 'T'));
        
        // approver
        // This is the name of the user that approved creation of these Class C Wells
        wellMessage.addChildElement('approver', namespace, 'wcp').
        addTextNode(approver.Name);
        
        // user_email
        // This is the email of the user that sent the create action
        wellMessage.addChildElement('user_email', namespace, 'wcp').
        addTextNode(userEmail);
        
        // messageAction
        // This is one of CREATE, UPDATE, or DELETE. In this code, it will always be CREATE
        wellMessage.addChildElement('messageAction', namespace, 'wcp').
        addTextNode('CREATE');
        
        if(isApproved)
        {
            // approved
            // Only present if we're approving the creation of the Class D Wells.
            // (Which we'll always be doing in this code.)
            wellMessage.addChildElement('approved', namespace, 'wcp');
        }
        /* End header information for well_message block */
        
        // well_bore
        // This is a list of all Class D Wells we're approving and creating
        if(wells.size() > 0)
        {
          /* Logic to organize well_bores with associated well bores using the new Associated_well__c field */
          // We need to loop through the wells to organize them into associated buckets, then rebuild the well list properly
          
          // First we build base buckets for each well that does not contain and Associated_well__c field
          // The wells that have associated fields get put back in the well list
          
          // This struct is a list of buckets
          List<List<Class_D_Well__c>> wellBucketsList = new List<List<Class_D_Well__c>>();
          
          // Turn each well into a bucket so it can hold associated wells
          for(Class_D_Well__c well : wells) {
              // Create the bucket list
              List<Class_D_Well__c> bucket = new List<Class_D_Well__c>();
              // Add the current well into the buckets list
              bucket.add(well);
              wellBucketsList.add(bucket);
          }
          
            // If a well is added, keep this as true
            Boolean wellAdded = true;
            // Keep track of which bucket to remove as we combine bucket
            Integer wellRemovalIndex = 0;
            while(wellAdded) {
                  // Set the well added to false
                  wellAdded = false;
                  // Reset the well removal index and increase it as we loop through
                  wellRemovalIndex = 0;
              for(List<Class_D_Well__c> wellLists : wellBucketsList)
              {
                  // Get most recent well for this list
                  Class_D_Well__c currentWell = wellLists[wellLists.size()-1];
                  // Loop through the other wellBucketsList lists
                  for(List<Class_D_Well__c> wellLists2 : wellBucketsList) {
                        // Get current well for the 2nd well list
                        Class_D_Well__c assocWell = wellLists2[wellLists2.size()-1];
                        // Check if location matches last well entered in this list, as not to add duplicates
                        if(currentWell.UWI_Location__c != assocWell.UWI_Location__c) {
                            if(assocWell.Associated_Well__c != null && currentWell.UWI_Location__c == assocWell.Associated_Well__c) {
                                // Add the entire well list that the current well belongs to, to the current bucket that matched
                                
                                // Make sure the well you are adding has it's associated well not blank, if blank assign it to the one it got assigned to
                                if(wellLists[wellLists.size()-1].Associated_Well__c == null) {
                                    wellLists[wellLists.size()-1].Associated_Well__c = assocWell.UWI_Location__c;
                                }
                                for(Class_D_Well__c wellsToAdd : wellLists) {
                                    if(wellsToAdd.Associated_Well__c == null) {
                                        wellsToAdd.Associated_Well__c = wellLists2[wellLists2.size()-1].UWI_Location__c;
                                    }
                                    wellLists2.add(wellsToAdd);
                                }
                                wellLists2[0].Associated_Well__c = null;
                                // Well has been added to list, can now break out
                                wellAdded = true;
                            }
                        }
                        // Break out if well is added
                        if(wellAdded) {
                            break;
                        }
                  }
                  //If a well has been added and combined into another bucket, remove the combined bucket
                  if(wellAdded) {
                    break;
                  }
                  wellRemovalIndex++;
              }
              // If a well has been added and combined into another bucket, remove the combined bucket
              if(wellAdded) {
                  wellBucketsList.remove(wellRemovalIndex);
              }
            }
          
          // Buckets should now be in the form (cycles, singles without associations, singles with associations not in the same list)
          // We now want to go through and put singles with the same associations in the same bucket   
          wellAdded = true;
          while(wellAdded) {
              wellAdded = false;
              wellRemovalIndex = 0;
              for(List<Class_D_Well__c> wellLists : wellBucketsList)
              {
                  // Get most recent well for this list
                  Class_D_Well__c currentWell = wellLists[wellLists.size()-1];
                  // Loop through the other wellBucketsList lists
                  for(List<Class_D_Well__c> wellLists2 : wellBucketsList) {
                        // Get current well for the 2nd well list
                        Class_D_Well__c assocWell = wellLists2[wellLists2.size()-1];
                        // Check if location matches last well entered in this list, as not to add duplicates
                        if(currentWell.UWI_Location__c != assocWell.UWI_Location__c) {
                            if(assocWell.Associated_Well__c != null && currentWell.Associated_Well__c != null && currentWell.Associated_Well__c == assocWell.Associated_Well__c) {
                                // Add the entire well list that the current well belongs to, to the current bucket that matched
                                for(Class_D_Well__c wellsToAdd : wellLists) {
                                    wellLists2.add(wellsToAdd);
                                }
                                // Well has been added to list, can now break out
                                wellAdded = true;
                            }
                        }
                        // Break out if well is added
                        if(wellAdded) {
                            break;
                        }
                  }
                  // If a well has been added and combined into another bucket, remove the combined bucket
                  if(wellAdded) {
                    break;
                  }
                  wellRemovalIndex++;
              }
              // If a well has been added and combined into another bucket, remove the combined bucket
              if(wellAdded) {
                  wellBucketsList.remove(wellRemovalIndex);
              }
          }
          
                    
          System.debug('There are ' + wellBucketsList.size() + ' buckets total');
          for(List<Class_D_Well__c> debugList : wellBucketsList) {
                System.debug('This bucket has ' + debugList.size() + ' wells in it.');
                for(Class_D_Well__c debugWell : debugList) {
                    System.debug('This well has a UWI of : ' + debugWell.UWI_Location__c);
                    System.debug('This well has an Association of : ' + debugWell.Associated_Well__c);
                }
          }

          // Now we loop through the new list created that does not have the 
          /* Start wells block */
          // Add the wells element to enclose all wells
          dom.XmlNode wellsNode = wellMessage.addChildElement('wells', namespace, 'wcp');
          
            // Loop through each bucket
            for(List<Class_D_Well__c> wellBucket : wellBucketsList) {
              /* Start well block */
              // Add the well element for each well to the wells element
              dom.XmlNode wellNode = wellsNode.addChildElement('well', namespace, 'wcp');
              // Add well_bores for each well
              dom.XmlNode wellBores = wellNode.addChildElement('well_bores', namespace, 'wcp');
                
                String wellSurfaceLocation;  
                // Loop through each well in the bucket and group them in the same well tag but seperate bore
                for(Class_D_Well__c well : wellBucket)
                {
                    wellSurfaceLocation = well.Surface_Location__c;
                    /* Start well_bore block */
                    // Add well_bore for each well
                    dom.XmlNode wellBore = wellBores.addChildElement('well_bore', namespace, 'wcp');
            
                    //
                    // Class D Well fields we need added to the wellBore element
                    //
                    
                    wellBore.addChildElement('SFID', namespace, 'wcp').
                    addTextNode(well.Id);
                    
                    wellBore.addChildElement('class', namespace, 'wcp').
                    addTextNode('C');
                    
                    wellBore.addChildElement('target_formation', namespace, 'wcp').
                    addTextNode(well.Target_Formation__c);
                    
                    wellBore.addChildElement('type', namespace, 'wcp').
                    addTextNode(well.Well_Type__c);
                    
                    if(well.Geologist__c != null)
                        wellBore.addChildElement('geologist', namespace, 'wcp').addTextNode(well.Geologist__c);
                    else
                        wellBore.addChildElement('geologist', namespace, 'wcp');
                    
                    if(well.Measured_Depth__c != null)
                        wellBore.addChildElement('measured_depth', namespace, 'wcp').addTextNode(String.valueOf(well.Measured_Depth__c));
                    else
                        wellBore.addChildElement('measured_depth', namespace, 'wcp');
                    
                    if(well.Horizontal_Length__c != null)
                        wellBore.addChildElement('hz_length', namespace, 'wcp').addTextNode(String.valueOf(well.Horizontal_Length__c));
                    else
                        wellBore.addChildElement('hz_length', namespace, 'wcp');
                    
                    if(well.Working_Interest__c != null)
                        wellBore.addChildElement('working_interest', namespace, 'wcp').addTextNode(String.valueOf(well.Working_Interest__c));
                    else
                        wellBore.addChildElement('working_interest', namespace, 'wcp');
                    
                    if(well.True_Vertical_Depth__c != null)
                        wellBore.addChildElement('well_tvd', namespace, 'wcp').addTextNode(String.valueOf(well.True_Vertical_Depth__c));
                    else
                        wellBore.addChildElement('well_tvd', namespace, 'wcp');
                    
                    if(well.Well_Category__c != null)
                        wellBore.addChildElement('category', namespace, 'wcp').addTextNode(well.Well_Category__c);
                    else
                        wellBore.addChildElement('category', namespace, 'wcp');
                    
                    wellBore.addChildElement('risked', namespace, 'wcp').addTextNode(String.valueOf(well.Risked__c));
                    
                    wellBore.addChildElement('primary_product', namespace, 'wcp').addTextNode(well.Primary_Product__c);
                    
                    wellBore.addChildElement('op_non_op', namespace, 'wcp').addTextNode(well.Op_Non_Op__c);
                    
                    wellBore.addChildElement('pool', namespace, 'wcp').addTextNode(well.Pool__c);
                    
                    wellBore.addChildElement('strategy', namespace, 'wcp').addTextNode(well.Strategy__c);
                    
                    /* Start well_locations block including UWI and Target locations */
                    
                    // This element encloses each location type for this well
                    dom.XmlNode wellLocations = wellBore.addChildElement('well_locations', namespace, 'wcp');
                  
                    // Target location
                    // First check to see if Target Location exists since it is not required
                    if(well.Target_Location__c != null) {
                        dom.XmlNode wellLocationTarget = wellLocations.addChildElement('target_location', namespace, 'wcp');
                        // Name of location
                        wellLocationTarget.addChildElement('dls_location', namespace, 'wcp').
                        addTextNode(well.Target_Location__c);
                        // Type of location
                        wellLocationTarget.addChildElement('dls_type', namespace, 'wcp').
                        addTextNode('Target');
                        // Field id and district id
                        if(fields.get(well.Operating_Field__c).AMU_GUID__c != null)
                        {
                            //wellLocationTarget.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).GRD_ID__c);
                            //wellLocationTarget.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).Operating_District__r.GRD_ID__c);
                            wellLocationTarget.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).AMU_GUID__c);
                        }
                        else
                        {
                            //wellLocationTarget.addChildElement('field_id', namespace, 'wcp');
                            //wellLocationTarget.addChildElement('district_id', namespace, 'wcp');
                            wellLocationTarget.addChildElement('amu_guid', namespace, 'wcp');
                        }
                    }
                  
                    // UWI Location
                    dom.XmlNode wellLocationUWI = wellLocations.addChildElement('UWI_location', namespace, 'wcp');
                    // Name of location
                    wellLocationUWI.addChildElement('dls_location', namespace, 'wcp').
                    addTextNode(well.UWI_Location__c); 
                    // Type of location
                    wellLocationUWI.addChildElement('dls_type', namespace, 'wcp').
                    addTextNode('UWI');
                    // Field id and district id
                    if(fields.get(well.Operating_Field__c).AMU_GUID__c != null)
                    {
                        //wellLocationUWI.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).GRD_ID__c);
                        //wellLocationUWI.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).Operating_District__r.GRD_ID__c);
                        wellLocationUWI.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(well.Operating_Field__c).AMU_GUID__c);
                    }
                    else
                    {
                        //wellLocationUWI.addChildElement('field_id', namespace, 'wcp');
                        //wellLocationUWI.addChildElement('district_id', namespace, 'wcp');
                        wellLocationUWI.addChildElement('amu_guid', namespace, 'wcp');
                    }
                    
                    /* End well_locations block */


                    if(well.Associated_Well__c != null)
                        wellBore.addChildElement('associated_well', namespace, 'wcp').addTextNode(well.Associated_Well__c);
                    else
                        wellBore.addChildElement('associated_well', namespace, 'wcp');
                    
                    /* Start completions block */
                    // Also check if we have any completions and add those in
                    if(well.Class_D_Well_Completions__r.size() > 0) {
                      // Add completions element
                      dom.XmlNode completionsNode = wellBore.addChildElement('completions', namespace, 'wcp');
                      // Loop through completions and add them in for this well
                      for(Class_D_Well_Completion__c completion : well.Class_D_Well_Completions__r)
                      {
                          // Add the completion element for this completion
                          dom.XmlNode completionNode = completionsNode.addChildElement('completion', namespace, 'wcp');
                          
                          //
                          // Completion fields we need
                          //
                          
                          // Add in completion_guid later
                          
                          // completion_fluid
                          if (completion.CompletionFluid__c != null)
                            completionNode.addChildElement('completion_fluid', namespace, 'wcp').addTextNode(completion.CompletionFluid__c);
                          // number_fracs
                          if (completion.NumberOfFracs__c != null)
                            completionNode.addChildElement('number_fracs', namespace, 'wcp').addTextNode(String.valueOf(completion.NumberOfFracs__c));
                          
                          // proppant_per_frac
                          if (completion.TProppantPerFrac__c != null)
                            completionNode.addChildElement('proppant_per_frac', namespace, 'wcp').addTextNode(String.valueOf(completion.TProppantPerFrac__c));
                          
                          // category_isolation
                          if (completion.CategoryIsolationCode__c != null)
                          completionNode.addChildElement('category_isolation', namespace, 'wcp').addTextNode(completion.CategoryIsolationCode__c);
                          
                          // proppant_size
                          if (completion.proppant_Size__c != null)
                            completionNode.addChildElement('proppant_size', namespace, 'wcp').addTextNode(String.valueOf(completion.proppant_Size__c));
                          
                          // proppant_type
                          if (completion.proppant_Type__c != null)
                            completionNode.addChildElement('proppant_type', namespace, 'wcp').addTextNode(completion.proppant_Type__c);
                      }
                    }
                    /* End completions block */
                    
                  /* End well_bore block */
                }
                
                // Add in surface location tag for all above well bores
                // Surface location
                dom.XmlNode wellSurface = wellNode.addChildElement('surface_location', namespace, 'wcp');
                // Name of location
                wellSurface.addChildElement('dls_location', namespace, 'wcp').
                addTextNode(wellSurfaceLocation);
                // Type of location
                wellSurface.addChildElement('dls_type', namespace, 'wcp').
                addTextNode('Surface');
                // Field id and district id
                if(fields.get(wellBucket[0].Operating_Field__c).AMU_GUID__c != null)
                {
                    //wellSurface.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(wellBucket[0].Operating_Field__c).GRD_ID__c);
                    //wellSurface.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(wellBucket[0].Operating_Field__c).Operating_District__r.GRD_ID__c);
                    wellSurface.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(wellBucket[0].Operating_Field__c).AMU_GUID__c);
                }
                else
                {
                    //wellSurface.addChildElement('field_id', namespace, 'wcp');
                    //wellSurface.addChildElement('district_id', namespace, 'wcp');
                    wellSurface.addChildElement('amu_guid', namespace, 'wcp');
                }
                
                /* End well block */  
            }
            
            /* End wells block */
        }
        
        /* End well_message block */
        // Return the XML Doc
        return doc;
    }
    
    // TODO: Add in type field or get clarification on type field
    // This method generates an XML request from a set of wellIds for class C wells
    public static Dom.Document generateClassCXML(List<Borehole> wells,
                                                 Set<Id> wellIds,
                                                 String  userEmail)
    {
        
system.debug('mikep wells '+wells);
        
        // Xml created using DOM Xml
        // Create the request envelope
        DOM.Document doc = new DOM.Document();
        
        // Fetch the class C wells we need and the appropriate fields
        // As well as the well completion child relationships associated with the wells
        
        Map<Id, GRD_Borehole__c> wellMap = new Map<Id, GRD_Borehole__C>([SELECT Id,
                                                                                Name,
                                                                                Target_Formation__c,
                                                                                MD__c,
                                                                                Horizontal_Length__c,
                                                                                True_Vertical_Depth__c,
                                                                                Geologist__c,
                                                                                Well_Category__c,
                                                                                Working_Interest__c,
                                                                                UWI_Location__r.Surface_Location__c,
                                                                                Target_Location__r.Name,
                                                                                UWI_Location__r.Name,
                                                                                UWI_Location__r.Well_Orientation__c,
                                                                                Well__r.Name,
                                                                                GRD_GUID__c,
                                                                                Strategy__c,
                                                                                Pool__c,
                                                                                Risked__c,
                                                                                Op_Non_Op__c,
                                                                                Primary_Product__c,
                                                                                Well__r.GRD_GUID__c,
                                                                                Well__r.WellView_GUID__c,
                                                                                ARC_GIS_GUID__c,
                                                                                PVR_Well_GUID__c,
                                                                                Type_Curve_GUID__c,
                                                                                WellView_Bore_GUID__c,
                                                                                (SELECT Id,
                                                                                        Name,
                                                                                        CategoryIsolationCode__c,
                                                                                        CompletionFluid__c,
                                                                                        NumberOfFracs__c,
                                                                                        TProppantPerFrac__c,
                                                                                        Proppant_Size__c,
                                                                                        Proppant_Type__c
                                                                                 FROM Class_C_Well_Completions__r)
                                                                          FROM GRD_Borehole__c
                                                                          WHERE Id IN: wellIds]);
        
        // Maps GRD GUIDs to the bore it came from
        Map<String,Id> GRDGUID2boreId = new Map<String,Id>();
        for(GRD_Borehole__c borehole : wellMap.values())
        {
            if(borehole.GRD_GUID__c != null)
            {
                GRDGUID2boreId.put(borehole.GRD_GUID__c,borehole.Id);
            }
        }
        
        // Get all mapped GUIDs for this borehole
        List<WCP_Data_Mapping__c> wellViewBoreDataMapping = [SELECT Id,
                                                                    Name,
                                                                    GUID__c,
                                                                    From_System__c,
                                                                    From_Table__c,
                                                                    From_Table_Key__c,
                                                                    To_System__c,
                                                                    To_Table__c,
                                                                    To_Table_Key__c,
                                                                    Mapping_Type__c
                                                             FROM WCP_Data_Mapping__c
                                                             WHERE Mapping_Type__c =: 'WELLBORE'       AND
                                                                   From_System__c  =: 'IAP'            AND
                                                                   From_Table__c   =: 'T_BORES'        AND
                                                                   To_System__c    =: 'WELLVIEW'       AND
                                                                   To_Table__c     =: 'WVT_WVWELLBORE' AND
                                                                   From_Table_Key__c IN: GRDGUID2boreId.keySet()];
        
        // Now traverse the list, storing for the WellView Bore GUIDS
        Map<String, String> boreId2WellViewBoreGUID = new Map<String, String>();
        Map<String, Id> wellViewBoreGUID2boreId = new Map<String, Id>();
        for(WCP_Data_Mapping__c dataMap : wellViewBoreDataMapping)
        {
            boreId2WellViewBoreGUID.put(GRDGUID2boreId.get(dataMap.From_Table_Key__c), dataMap.To_Table_Key__c);
            wellViewBoreGUID2boreId.put(dataMap.To_Table_Key__c, GRDGUID2boreId.get(dataMap.From_Table_Key__c));
        }
        
        // Query for all WellView zones
        List<WCP_Data_Mapping__c> wellViewZoneDataMapping = [SELECT Id,
                                                                    Name,
                                                                    GUID__c,
                                                                    From_System__c,
                                                                    From_Table__c,
                                                                    From_Table_Key__c,
                                                                    To_System__c,
                                                                    To_Table__c,
                                                                    To_Table_Key__c,
                                                                    Mapping_Type__c
                                                             FROM WCP_Data_Mapping__c
                                                             WHERE Mapping_Type__c =: 'BOREZONE'         AND
                                                                   From_System__c  =: 'WELLVIEW'         AND
                                                                   From_Table__c   =: 'WVT_WVWELLBORE' AND
                                                                   To_System__c    =: 'WELLVIEW'         AND
                                                                   To_Table__c     =: 'WVT_WVZONE'       AND
                                                                   From_Table_Key__c IN: wellViewBoreGUID2boreId.keySet()];
        
        // Store them
        Map<Id, Map<String, GUIDMapping>> boreId2GUIDMapping = new Map<Id, Map<String, GUIDMapping>>();
        Map<String, Id> wellViewZone2boreId = new Map<String, Id>();
        for(WCP_Data_Mapping__c dataMap : wellViewZoneDataMapping)
        {
            if(wellViewBoreGUID2boreId.containsKey(dataMap.From_Table_Key__c))
            {
                if(!boreId2GUIDMapping.containsKey(wellViewBoreGUID2boreId.get(dataMap.From_Table_Key__c)))
                {
                    boreId2GUIDMapping.put(wellViewBoreGUID2boreId.get(dataMap.From_Table_Key__c), new Map<String, GUIDMapping>());
                }
                
                GUIDMapping gm = new GUIDMapping();
                gm.wellViewZoneSFID = dataMap.Id;
                gm.wellViewZoneGUID = dataMap.GUID__c;
                gm.wellViewZone     = dataMap.To_Table_Key__c;
                
                wellViewZone2boreId.put(dataMap.To_Table_Key__c, wellViewBoreGUID2boreId.get(dataMap.From_Table_Key__c));
                
                boreId2GUIDMapping.get(wellViewBoreGUID2boreId.get(dataMap.From_Table_Key__c)).put(dataMap.To_Table_Key__c, gm);
            }
        }
        
        // Now query and add all PVR GUIDs
        List<WCP_Data_Mapping__c> PVRWellDataMapping = [SELECT Id,
                                                               Name,
                                                               GUID__c,
                                                               From_System__c,
                                                               From_Table__c,
                                                               From_Table_Key__c,
                                                               To_System__c,
                                                               To_Table__c,
                                                               To_Table_Key__c,
                                                               Mapping_Type__c
                                                        FROM WCP_Data_Mapping__c
                                                        WHERE Mapping_Type__c =: 'ZONE'       AND
                                                              From_System__c  =: 'WELLVIEW'   AND
                                                              From_Table__c   =: 'WVT_WVZONE' AND
                                                              To_System__c    =: 'PVR'        AND
                                                              To_Table__c     =: 'FDC_TWELL'  AND
                                                              From_Table_Key__c IN: wellViewZone2boreId.keySet()];
        
        for(WCP_Data_Mapping__c dataMap : PVRWellDataMapping)
        {
            if(wellViewZone2boreId.containsKey(dataMap.From_Table_Key__c))
            {
                if(boreId2GUIDMapping.containsKey(wellViewZone2boreId.get(dataMap.From_Table_Key__c)))
                {
                    if(boreId2GUIDMapping.get(wellViewZone2boreId.get(dataMap.From_Table_Key__c)).containsKey(dataMap.From_Table_Key__c))
                    {
                        boreId2GUIDMapping.get(wellViewZone2boreId.get(dataMap.From_Table_Key__c)).get(dataMap.From_Table_Key__c).PVRWellSFID = dataMap.Id;
                        boreId2GUIDMapping.get(wellViewZone2boreId.get(dataMap.From_Table_Key__c)).get(dataMap.From_Table_Key__c).PVRWellGUID = dataMap.GUID__c;
                        boreId2GUIDMapping.get(wellViewZone2boreId.get(dataMap.From_Table_Key__c)).get(dataMap.From_Table_Key__c).PVRWell     = dataMap.To_Table_Key__c;
                    }
                }
            }
        }
        
        
        
        
        
        for(Borehole b : wells)
        {
            if(boreId2GUIDMapping.containsKey(b.Id))
            {
//                b.GUIDMappings = boreId2GUIDMapping.get(b.Id).values();
            }
        }
        
system.debug('mike0 wells '+wells);
        
        
        
        
        
        
        
        // Select the Operating Fields and Districts used by those Class D Wells. We'll need to send them too.
        Set<String> fieldNames = new Set<String>();
        Map<String,Field__c> fields = new Map<String,Field__c>();
        
        for(Borehole well : wells)
        {
            fieldNames.add(well.operatingField);
        }
        
        List<Field__c> fieldData = [SELECT Id,
                                           Name,
                                           GRD_ID__c,
                                           Operating_District__c,
                                           Operating_District__r.Name,
                                           Operating_District__r.GRD_ID__c,
                                           AMU_GUID__c
                                    FROM Field__c
                                    WHERE Name IN: fieldNames];

        for(Field__c eachField : fieldData)
        {
            if(!fields.containsKey(eachField.Name) && eachField.GRD_ID__c != null)
                fields.put(eachField.Name, eachField);
        }
        
        // Set up the URL to the namespace
        String namespace    = 'http://wcp.huskyenergy.com/wellentry';
        
        /* Start well_message block */
        // Create the root element wellMessage and add attributes needed
        dom.XmlNode wellMessage = doc.createRootElement('well_message', namespace, 'wcp');
        wellMessage.setAttribute('xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
        wellMessage.setAttribute('xsi:schemaLocation', 'http://wcp.huskyenergy.com/wellentry http://wcp.huskyenergy.com/wellentry');

        /* Start header information for well_message block */
        
        
        // session_id
        // This is the email of the user that sent the create action concat. to the current timestamp
        wellMessage.addChildElement('session_id', namespace, 'wcp').
        addTextNode(userEmail+'@'+string.valueof(System.now()).replace(' ', 'T'));
        
        
        // message_dttm
        // This is the date/time for the message
        wellMessage.addChildElement('message_dttm', namespace, 'wcp').
        addTextNode(string.valueof(System.now()).replace(' ', 'T'));
        
        // approver
        // This is the name of the user that approved creation of these Class C Wells
        wellMessage.addChildElement('approver', namespace, 'wcp').addTextNode(UserInfo.getName());
        
        // user_email
        // This is the email of the user that sent the create action
        wellMessage.addChildElement('user_email', namespace, 'wcp').
        addTextNode(userEmail);
        
        // messageAction
        // This is one of CREATE, UPDATE, or DELETE. In this code, it will always be UPDATE
        wellMessage.addChildElement('messageAction', namespace, 'wcp').   
        addTextNode('UPDATE');
        
        // This is a list of all Class C Wells we're approving and creating
        if(wells.size() > 0)
        {
          /* Start wells block */
          // Add the wells element to enclose all wells
          dom.XmlNode wellsNode = wellMessage.addChildElement('wells', namespace, 'wcp');
          
            // Loop through each bucket
            for(Borehole well : wells) {
              /* Start well block */
              // Add the well element for each well to the wells element
              dom.XmlNode wellNode = wellsNode.addChildElement('well', namespace, 'wcp');
              
              // Add proper GUIDs for Class C well
              if(wellMap.containsKey(well.Id))
              {
                  wellNode.addChildElement('well_guid', namespace, 'wcp').addTextNode(wellMap.get(well.Id).Well__r.GRD_GUID__c);
                  if(wellMap.get(well.Id).Well__r.WellView_GUID__c != null)
                  {
                      wellNode.addChildElement('wellview_guid', namespace, 'wcp').addTextNode(wellMap.get(well.Id).Well__r.WellView_GUID__c);
                  }
              }
              
              // Add well_bores for each well
              dom.XmlNode wellBores = wellNode.addChildElement('well_bores', namespace, 'wcp');
                
                /* Start well_bore block */
                // Add well_bore for each well
                dom.XmlNode wellBore = wellBores.addChildElement('well_bore', namespace, 'wcp');
        
                //
                // Class D Well fields we need added to the wellBore element
                //
                
                wellBore.addChildElement('bore_guid', namespace, 'wcp').
                addTextNode(wellMap.get(well.Id).GRD_GUID__c);
                
                wellBore.addChildElement('SFID', namespace, 'wcp').
                addTextNode(well.Id);
                
                wellBore.addChildElement('class', namespace, 'wcp').
                addTextNode(well.wellClass);
                
                wellBore.addChildElement('target_formation', namespace, 'wcp').
                addTextNode(well.targetFormation);
                
                wellBore.addChildElement('type', namespace, 'wcp').
                addTextNode(well.wellType);
                
                wellBore.addChildElement('geologist', namespace, 'wcp').addTextNode(well.geologist);
                
                wellBore.addChildElement('measured_depth', namespace, 'wcp').addTextNode(String.valueOf(well.measuredDepth));
                
                wellBore.addChildElement('hz_length', namespace, 'wcp').addTextNode(String.valueOf(well.horizontalLength));
            
                wellBore.addChildElement('working_interest', namespace, 'wcp').addTextNode(String.valueOf(well.workingInterest));
            
                wellBore.addChildElement('well_tvd', namespace, 'wcp').addTextNode(String.valueOf(well.trueVerticalDepth));
            
                wellBore.addChildElement('category', namespace, 'wcp').addTextNode(well.wellCategory);
                
                wellBore.addChildElement('risked', namespace, 'wcp').addTextNode(String.valueOf(well.risk));
                
                wellBore.addChildElement('primary_product', namespace, 'wcp').addTextNode(well.primaryProduct);
                
                wellBore.addChildElement('op_non_op', namespace, 'wcp').addTextNode(well.opNonOp);
                
                wellBore.addChildElement('pool', namespace, 'wcp').addTextNode(well.pool);
                
                wellBore.addChildElement('strategy', namespace, 'wcp').addTextNode(well.strategy);
                
                /* Start well_locations block including UWI and Target locations */
                
                // This element encloses each location type for this well
                dom.XmlNode wellLocations = wellBore.addChildElement('well_locations', namespace, 'wcp');
              
                // Target location
                // First check to see if Target Location exists since it is not required
                if(well.targetLocId != null) {
                    dom.XmlNode wellLocationTarget = wellLocations.addChildElement('target_location', namespace, 'wcp');
                    // Name of location
                    wellLocationTarget.addChildElement('dls_location', namespace, 'wcp').
                    addTextNode(well.targetLocation);
                    // Type of location
                    wellLocationTarget.addChildElement('dls_type', namespace, 'wcp').
                    addTextNode('Target');  
                    // Field id and district id
                    if(fields.get(well.operatingField).AMU_GUID__c != null)
                    {
                        //wellLocationTarget.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).GRD_ID__c);
                        //wellLocationTarget.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).Operating_District__r.GRD_ID__c);
                        wellLocationTarget.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(well.operatingField).AMU_GUID__c);
                    }
                    else
                    {
                        //wellLocationTarget.addChildElement('field_id', namespace, 'wcp');
                        //wellLocationTarget.addChildElement('district_id', namespace, 'wcp');
                        wellLocationTarget.addChildElement('amu_guid', namespace, 'wcp');
                    }
                }
              
                // UWI Location
                dom.XmlNode wellLocationUWI = wellLocations.addChildElement('UWI_location', namespace, 'wcp');
                // Name of location
                wellLocationUWI.addChildElement('dls_location', namespace, 'wcp').
                addTextNode(well.uwiLocation); 
                // Type of location
                wellLocationUWI.addChildElement('dls_type', namespace, 'wcp').
                addTextNode('UWI');
                // Field id and district id
                if(fields.get(well.operatingField).AMU_GUID__c != null)
                {
                    //wellLocationUWI.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).GRD_ID__c);
                    //wellLocationUWI.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).Operating_District__r.GRD_ID__c);
                    wellLocationUWI.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(well.operatingField).AMU_GUID__c);
                }
                else
                {
                    //wellLocationUWI.addChildElement('field_id', namespace, 'wcp');
                    //wellLocationUWI.addChildElement('district_id', namespace, 'wcp');
                    wellLocationUWI.addChildElement('amu_guid', namespace, 'wcp');
                }
                 
                /* End well_locations block */

                
                //////if(boreId2WellViewBoreGUID.containsKey(well.Id) && boreId2WellViewBoreGUID.get(well.Id) != null)
                //////    wellBore.addChildElement('wellviewboreguid', namespace, 'wcp').addTextNode(boreId2WellViewBoreGUID.get(well.Id));
                if(well.wellViewBoreGUID != null)
                    wellBore.addChildElement('wellviewboreguid', namespace, 'wcp').addTextNode(well.wellViewBoreGUID);
                
                wellBore.addChildElement('pvrwellguid', namespace, 'wcp').addTextNode(well.pvrGUID);
                wellBore.addChildElement('arcgisguid', namespace, 'wcp').addTextNode(well.arcGUID);
                wellBore.addChildElement('typecurveheaderguid', namespace, 'wcp').addTextNode(well.typeCurveGUID);
                    
                /* Start completions block */
                // Also check if we have any completions and add those in
                if(well.completions != null && well.completions.size() > 0) {
                  // Add completions element
                  dom.XmlNode completionsNode = wellBore.addChildElement('completions', namespace, 'wcp');
                  // Loop through completions and add them in for this well
                  for(Completion completion : well.Completions)
                  {
                    // Add the completion element for this completion
                    dom.XmlNode completionNode = completionsNode.addChildElement('completion', namespace, 'wcp');
                      //
                      // Completion fields we need
                      //
                      
                      // Add in completion_guid later
                      
                      
                      completionNode.addChildElement('completion_guid', namespace, 'wcp').addTextNode(completion.completionGUID);
                      
                      // completion_fluid
                      completionNode.addChildElement('completion_fluid', namespace, 'wcp').addTextNode(completion.CompletionFluid);
                      
                      // number_fracs
                      if (completion.numberOfStages != '')
                      {
                        completionNode.addChildElement('number_fracs', namespace, 'wcp').
                        addTextNode(completion.numberOfStages);
                      }
                      // proppant_per_frac
                      if (completion.sizeofstages != '')
                      {
                        completionNode.addChildElement('proppant_per_frac', namespace, 'wcp').
                        addTextNode(completion.sizeofstages);
                      }
                      // category_isolation
                      completionNode.addChildElement('category_isolation', namespace, 'wcp').
                      addTextNode(completion.categoryIsolation);
                      
                      // proppant_size
                      completionNode.addChildElement('proppant_size', namespace, 'wcp').addTextNode(completion.proppantSize);
                      
                      // proppant_type
                      completionNode.addChildElement('proppant_type', namespace, 'wcp').addTextNode(completion.proppantType);
                  }
                }
                /* End completions block */
               
                if(well.GUIDMappings != null && well.GUIDMappings.size() > 0)
                {
                    dom.XmlNode GUIDMappingsNode = wellBore.addChildElement('zone_mappings', namespace, 'wcp');
                    
                    for(GUIDMapping gm : well.GUIDMappings)
                    {
                        dom.XmlNode mappingNode = GUIDMappingsNode.addChildElement('zone_mapping', namespace, 'wcp');
                        
                        mappingNode.addChildElement('wellviewzoneguid',        namespace, 'wcp').addTextNode(gm.wellViewZone);
                        if(gm.wellViewZoneGUID != null)
                            mappingNode.addChildElement('wellviewzonemappingguid', namespace, 'wcp').addTextNode(gm.wellViewZoneGUID);
                        else
                            mappingNode.addChildElement('wellviewzonemappingguid', namespace, 'wcp');
                        mappingNode.addChildElement('wellviewsfid',            namespace, 'wcp').addTextNode(gm.wellViewZoneSFID);
                        mappingNode.addChildElement('pvrguid',                 namespace, 'wcp').addTextNode(gm.PVRWell);
                        if(gm.PVRWellGUID != null)
                            mappingNode.addChildElement('pvrmappingguid',          namespace, 'wcp').addTextNode(gm.PVRWellGUID);
                        else
                            mappingNode.addChildElement('pvrmappingguid',          namespace, 'wcp');
                        mappingNode.addChildElement('pvrsfid',                 namespace, 'wcp').addTextNode(gm.PVRWellSFID);
                    }
                }
               
                /* End well_bore block */
                
                // Add in surface location tag for all above well bores
                // Surface location
                dom.XmlNode wellSurface = wellNode.addChildElement('surface_location', namespace, 'wcp');
                // Name of location
                wellSurface.addChildElement('dls_location', namespace, 'wcp').
                addTextNode(well.surfaceLocation);
                // Type of location
                wellSurface.addChildElement('dls_type', namespace, 'wcp').
                addTextNode('Surface');
                // Field id and district id
                if(fields.get(well.operatingField).AMU_GUID__c != null)
                {
                    //wellSurface.addChildElement('field_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).GRD_ID__c);
                    //wellSurface.addChildElement('district_id', namespace, 'wcp').addTextNode(fields.get(well.operatingField).Operating_District__r.GRD_ID__c);
                    wellSurface.addChildElement('amu_guid', namespace, 'wcp').addTextNode(fields.get(well.operatingField).AMU_GUID__c);
                }
                else
                {
                    //wellSurface.addChildElement('field_id', namespace, 'wcp');
                    //wellSurface.addChildElement('district_id', namespace, 'wcp');
                    wellSurface.addChildElement('amu_guid', namespace, 'wcp');
                }
                
                /* End well block */  
            }
            
            /* End wells block */
        }
        
        /* End well_message block */    



        // Return the XML Doc
        return doc;
    }
    
    
    /*  This is Mule REST API URL patterns  
        dev:
        https://salesforce-wcp-dv.huskyenergy.com:8001/......
        test:
        https://salesforce-wcp-qa.huskyenergy.com:8001/......
        ps:
        https://salesforce-wcp-ps.huskyenergy.com:8001/......
        prod:
        https://salesforce-wcp.huskyenergy.com:8001/......    
    */    
    // Sends an XML string to Mulesoft to the passed to a WCP database
    public static Map<String,Map<Id,String>> sendXMLtoMule(DOM.Document doc, Set<Id> wellIds, String wellclass, String schemaName)
    {
        // Get certificate name
        System.debug('sendXMLtoMule wellIds =' + wellIds + '  schemaName =' + schemaName);
        USCP_Settings__c mc = USCP_Settings__c.getOrgDefaults();
        String WS_CertificateName = mc.HEI_WS_CertificateName__c;
        
        // Where we're sending the XML to
        String endpointUrl;
        String muleHost = getMuleHost();
        
        if(wellclass == 'D')
            endpointUrl = 'https://salesforce-wcp' + muleHost + '.huskyenergy.com:8001/biPortalGrd/'+schemaName+'/classDWell';
        else
            endpointUrl = 'https://salesforce-wcp' + muleHost + '.huskyenergy.com:8001/biPortalGrd/'+schemaName+'/classCWell';
        
        // Instantiate a new http object
        Http h = new Http();    
        
        // Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
        HttpRequest req = new HttpRequest();
        
        // The body is the XML string
        req.setBody(doc.toXmlString());
        
        system.debug(doc.toXmlString());
        
        // Tell the http request where to go
        req.setEndpoint(endpointUrl);
        
        // Specify certificate
        if(WS_CertificateName != null) req.setClientCertificateName(WS_CertificateName);
        
        req.setTimeout(120000);
        req.setMethod('POST');
        req.setHeader('Content-Type', 'text/xml');
        
        // This is the response we'll get back
        HttpResponse res;
        
        // Send the request, and return a response
        if(!Test.isRunningTest())
        {
            res = h.send(req);
        
            System.debug('XML to Mule reponse is '+res);
            System.debug('res.getBody() '+res.getBody());
            System.debug(res.getStatusCode()+' : '+res.getStatus());
        }
        
        Map<String,Map<Id,String>> results = new Map<String,Map<Id,String>>();
        results.put('Success',new Map<Id,String>());
        results.put('Fail',new Map<Id,String>());
        
        if(!Test.isRunningTest())
        {
            if(res.getStatusCode() != 200 && res.getStatusCode() != 500)
            {
                for(Id wellId : wellIds)
                {
                    results.get('Fail').put(wellId,'Unable to connect to server.');
                }
                return results;
            }
            else if(res.getStatusCode() == 500)
            {
                for(Id wellId : wellIds)
                {
                    results.get('Fail').put(wellId,res.getBody());
                }
                return results;
            }
            else
            {
                List<JSONresult> resultsList = (List<JSONresult>)JSON.deserialize(res.getBody(), List<JSONresult>.class);
                for(JSONresult result : resultsList)
                {
                    if(result.Status == 'SUCCESS')
                    {
                        results.get('Success').put(result.SFID,'');
                    }
                    else
                    {
                        results.get('Fail').put(result.SFID,result.Error);
                    }
                }
                return results;
            }
        }
        return results;
    }

    private static String getMuleHost(){
        String hostName = URL.getSalesforceBaseUrl().getHost().split('\\.')[0].toLowerCase();
        
        //TODO : Use enum ??
        if(hostName.containsIgnoreCase('--dev')){
            return '-dv';
        }
        
        if(hostName.containsIgnoreCase('--test')){
            return '-qa';
        }  
        
        if(hostName.containsIgnoreCase('--ps')){
            return '-ps';
        }                 
        
        return '';
    }

}